// Volume Library Interactive Sketch (c) 2016 Connor Nishijima
// Released under the GPLv3 license
//Some of the Sound functions, specifically gameboy and R2D2, are from the example code

#include "Volume.h" // Include the Volume library

Volume vol; // Plug your speaker into the default pin for your board type:
// https://github.com/connornishijima/arduino-volume#supported-pins

//Accelerometer Code From: https://www.electronicwings.com/arduino/adxl335-accelerometer-interfacing-with-arduino-uno

#include <math.h>
#define x_out A0
#define y_out A1
#define z_out A2

bool alarmState = false;

int delayTime = 1000;

int remTime = 30000;

int napCount = 0;

int e = 660;
int g = 784;
int a = 880;
int b = 988;
int c = 1046;

int fSharp =740;
int gSharp = 831;
int aSharp = 932;

int spacing = 125;

int buttonPin = 4;

// the setup routine runs once when you press reset:
void setup() {
  vol.begin();

  Serial.begin(9600);
  pinMode(x_out, INPUT);
  pinMode(y_out, INPUT);
  pinMode(z_out, INPUT);

  pinMode(buttonPin, INPUT);
}

// the loop routine runs over and over again forever:
void loop() {
  if (!alarmState) {
    int x_adc_value, y_adc_value, z_adc_value;
    double x_g_value, y_g_value, z_g_value;
    double roll, pitch, yaw;
    x_adc_value = analogRead(x_out); /* Digital value of voltage on x_out pin */
    y_adc_value = analogRead(y_out); /* Digital value of voltage on y_out pin */
    z_adc_value = analogRead(z_out); /* Digital value of voltage on z_out pin */
    Serial.print("x = ");
    Serial.print(x_adc_value);
    Serial.print("\t\t");
    Serial.print("y = ");
    Serial.print(y_adc_value);
    Serial.print("\t\t");
    Serial.print("z = ");
    Serial.print(z_adc_value);
    Serial.print("\t\t");
    //delay(100);

    x_g_value = ( ( ( (double)(x_adc_value * 5) / 1024) - 1.65 ) / 0.330 ); /* Acceleration in x-direction in g units */
    y_g_value = ( ( ( (double)(y_adc_value * 5) / 1024) - 1.65 ) / 0.330 ); /* Acceleration in y-direction in g units */
    z_g_value = ( ( ( (double)(z_adc_value * 5) / 1024) - 1.80 ) / 0.330 ); /* Acceleration in z-direction in g units */

    roll = ( ( (atan2(y_g_value, z_g_value) * 180) / 3.14 ) + 180 ); /* Formula for roll */
    pitch = ( ( (atan2(z_g_value, x_g_value) * 180) / 3.14 ) + 180 ); /* Formula for pitch */
    //yaw = ( ( (atan2(x_g_value,y_g_value) * 180) / 3.14 ) + 180 ); /* Formula for yaw */
    /* Not possible to measure yaw using accelerometer. Gyroscope must be used if yaw is also required */

    Serial.print("Roll = ");
    Serial.print(roll);
    Serial.print("\t");
    Serial.print("Pitch = ");
    Serial.print(pitch);
    Serial.print("\n\n");
    //  delay(delayTime);

    if (pitch > 130 || digitalRead(buttonPin)) {
      alarmState = true;
      gameboy();
    }

    if (pitch < 50) {
      johnCena();
      delay(10000);
      yawn();
    }
    
    if (pitch > 90 && pitch < 130) {
      johnCena();
      delay(10000);
      yawn();
    }
  }

  if (napCount > 3) {
    goodNight();
    napCount = 0;
  }
  
  if (alarmState) {
    ////////////////////////////////////////////////////////////////////////////////////////////
    //Sound Stuff
    ////////////////////////////////////////////////////////////////////////////////////////////
    delay(remTime);
    delay(remTime);
    delay(remTime);
    alarm();
    napCount++;
    alarmState = false;
    delay(5000);
  }
}

void alarm() {
  R2D2();
}


void goodNight () {
  vol.tone(e,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(e,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(g,255); // pa
  vol.delay(500);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  
  vol.tone(e,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(e,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(g,255); // pa
  vol.delay(500);
  vol.tone(1025,0); // pa
  vol.delay(spacing);

  vol.tone(e,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(g,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(c,255); // pa
  vol.delay(500);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(b,255); // pa
  vol.delay(500);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(a,255); // pa
  vol.delay(500);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  
  vol.tone(a,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(g,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
}

void johnCena() {
  vol.tone(gSharp,255); // pa
  vol.delay(300);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(aSharp,255); // pa
  vol.delay(175);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(fSharp,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(gSharp,255); // pa
  vol.delay(750);
  vol.tone(1025,0); // pa
  vol.delay(spacing);

  vol.tone(b,255); // pa
  vol.delay(300);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(aSharp,255); // pa
  vol.delay(175);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(fSharp,255); // pa
  vol.delay(250);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
  vol.tone(gSharp,255); // pa
  vol.delay(750);
  vol.tone(1025,0); // pa
  vol.delay(spacing);
}

void yawn() {
  int f = 1865; // starting frequency
  int v = 0;   // starting volume
  while (f > 1025) {  // slide up to 4000Hz
    vol.tone(f, v);
    v = 255 * (f / 4000.00);
    f -= 5;
    vol.delay(15);
  }
}

void gameboy(){
  vol.tone(1025,100); // pa
  vol.delay(250);
  int v = 100;
  while(v > 0){
    vol.tone(2090,v); // ting!
    vol.delay(3);
    v--;
  }
  vol.tone(1025,0); // pa
}

void R2D2() {
  int beeps[] = {1933, 2156, 1863, 1505, 1816, 1933, 1729, 2291};
  int buzzVols[] = {144, 180, 216, 252, 252, 252, 252, 216, 180, 144};

  int i = 9;
  while (i >= 0) {
    vol.tone(1050, buzzVols[i]);
    vol.delayMicroseconds(20);
    vol.tone(1050, buzzVols[i] / 8);
    vol.delayMicroseconds(40);
    i--;
  }

  vol.delay(35);

  i = 0;
  while (i < 8) {
    int v = 0;
    while (v < 250) { // 12.5 mS fade up time
      vol.tone(beeps[i], v);
      v += 10;
      vol.delayMicroseconds(2);
    }
    vol.delay(20);
    v = 250;
    while (v > 0) { // 12.5 mS fade down time
      vol.tone(beeps[i], v);
      v -= 10;
      vol.delayMicroseconds(5);
    }
    vol.noTone();
    vol.delay(35);
    i++;
  }

  int f = 2466;
  while (f < 2825) {
    vol.tone(f, 255);
    f += 3;
    vol.delay(1);
  }
  f = 2825;
  int v = 255;
  while (f > 2000) {
    vol.tone(f, v);
    f -= 6;
    v -= 1;
    vol.delay(1);
  }
  vol.noTone();
  vol.delay(35);

  i = 10;
  while (i > 0) {
    vol.tone(1050, buzzVols[i]);
    vol.delayMicroseconds(20);
    vol.tone(1050, buzzVols[i] / 8);
    vol.delayMicroseconds(40);
    i--;
  }
  vol.noTone();
}
