//Code From the Coding Train | ml5.js: KNN Classification Series: https://www.youtube.com/watch?v=KTNqXwkLuM4

let video;
let features;
let knn;
let labelP;
let ready = false;
let label = '';

var serial; 
var portName = 'COM3';
var outData;

var dozin = 0;
var aslep = 1;

function setup() {
  createCanvas(320,240);
  video = createCapture(VIDEO);
  video.size(320,240);
  video.hide();
  features = ml5.featureExtractor("MobileNet",modelReady);
  
  knn = ml5.KNNClassifier();
  labelP = createP("needs training data");
  labelP.style("font-size", "32pt");
  
  serial = new p5.SerialPort();
//   serial.on('list', printList);
//   serial.on('connected', serverConnected); // callback for connecting to the server
//   serial.on('open', portOpen);        // callback for the port opening
//   // serial.on('data', serialEvent);     // callback for when new data arrives
//   serial.on('error', serialError);    // callback for errors
//   serial.on('close', portClose);      // callback for the port closing
 
//   serial.list();                      // list the serial ports
//   serial.open(portName); 
}

function goClassify() {
  const logits = features.infer(video);
  knn.classify(logits, gotResult);
}  

function gotResult(error, result) {
  if (error) {
    console.error(error);
  } 
  else {
    label = result.label;
    labelP.html(result.label);
    console.log(result);
    goClassify();
  }
  
}  
  

function mousePressed() {
  if (knn.getNumLabels() > 0) {
    const logits = features.infer(video);
    knn.classify(logits, gotResult);
  }
}
  
function keyPressed() {
  const logits = features.infer(video);
  if (key == "l") {
    knn.addExample(logits,"awake");
    console.log("left");
  }
  else if (key == "r") {
    knn.addExample(logits,"dozing");
    console.log("right");
  }
  else if (key == "a") {
    knn.addExample(logits,"asleep");
    console.log("asleep");
  }
  else if (key == "s") {
    knn.save("model.json");
  }
  //console.log(logits.dataSync());
}
  
function modelReady() {
  console.log("model ready");
}
  
function draw() {
  image(video,0,0);
  if (!ready && knn.getNumLabels() > 0) {
    goClassify();
    ready = true;
  }
  
  if (label == "dozing") {
    outData = dozin;
    serial.write(outData);
  }
  
  if (label == "asleep") {
    outData = aslep;
    serial.write(outData);
  }
}
